// Code generated by sdkgen. DO NOT EDIT.

// nolint
package cic

import (
	"context"

	"google.golang.org/grpc"

	cic "github.com/yandex-cloud/go-genproto/yandex/cloud/cic/v1"
	"github.com/yandex-cloud/go-genproto/yandex/cloud/operation"
)

//revive:disable

// PrivateConnectionServiceClient is a cic.PrivateConnectionServiceClient with
// lazy GRPC connection initialization.
type PrivateConnectionServiceClient struct {
	getConn func(ctx context.Context) (*grpc.ClientConn, error)
}

// Create implements cic.PrivateConnectionServiceClient
func (c *PrivateConnectionServiceClient) Create(ctx context.Context, in *cic.CreatePrivateConnectionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewPrivateConnectionServiceClient(conn).Create(ctx, in, opts...)
}

// Delete implements cic.PrivateConnectionServiceClient
func (c *PrivateConnectionServiceClient) Delete(ctx context.Context, in *cic.DeletePrivateConnectionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewPrivateConnectionServiceClient(conn).Delete(ctx, in, opts...)
}

// Get implements cic.PrivateConnectionServiceClient
func (c *PrivateConnectionServiceClient) Get(ctx context.Context, in *cic.GetPrivateConnectionRequest, opts ...grpc.CallOption) (*cic.PrivateConnection, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewPrivateConnectionServiceClient(conn).Get(ctx, in, opts...)
}

// List implements cic.PrivateConnectionServiceClient
func (c *PrivateConnectionServiceClient) List(ctx context.Context, in *cic.ListPrivateConnectionsRequest, opts ...grpc.CallOption) (*cic.ListPrivateConnectionsResponse, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewPrivateConnectionServiceClient(conn).List(ctx, in, opts...)
}

type PrivateConnectionIterator struct {
	ctx  context.Context
	opts []grpc.CallOption

	err           error
	started       bool
	requestedSize int64
	pageSize      int64

	client  *PrivateConnectionServiceClient
	request *cic.ListPrivateConnectionsRequest

	items []*cic.PrivateConnection
}

func (c *PrivateConnectionServiceClient) PrivateConnectionIterator(ctx context.Context, req *cic.ListPrivateConnectionsRequest, opts ...grpc.CallOption) *PrivateConnectionIterator {
	var pageSize int64
	const defaultPageSize = 1000
	pageSize = req.PageSize
	if pageSize == 0 {
		pageSize = defaultPageSize
	}
	return &PrivateConnectionIterator{
		ctx:      ctx,
		opts:     opts,
		client:   c,
		request:  req,
		pageSize: pageSize,
	}
}

func (it *PrivateConnectionIterator) Next() bool {
	if it.err != nil {
		return false
	}
	if len(it.items) > 1 {
		it.items[0] = nil
		it.items = it.items[1:]
		return true
	}
	it.items = nil // consume last item, if any

	if it.started && it.request.PageToken == "" {
		return false
	}
	it.started = true

	if it.requestedSize == 0 || it.requestedSize > it.pageSize {
		it.request.PageSize = it.pageSize
	} else {
		it.request.PageSize = it.requestedSize
	}

	response, err := it.client.List(it.ctx, it.request, it.opts...)
	it.err = err
	if err != nil {
		return false
	}

	it.items = response.PrivateConnections
	it.request.PageToken = response.NextPageToken
	return len(it.items) > 0
}

func (it *PrivateConnectionIterator) Take(size int64) ([]*cic.PrivateConnection, error) {
	if it.err != nil {
		return nil, it.err
	}

	if size == 0 {
		size = 1 << 32 // something insanely large
	}
	it.requestedSize = size
	defer func() {
		// reset iterator for future calls.
		it.requestedSize = 0
	}()

	var result []*cic.PrivateConnection

	for it.requestedSize > 0 && it.Next() {
		it.requestedSize--
		result = append(result, it.Value())
	}

	if it.err != nil {
		return nil, it.err
	}

	return result, nil
}

func (it *PrivateConnectionIterator) TakeAll() ([]*cic.PrivateConnection, error) {
	return it.Take(0)
}

func (it *PrivateConnectionIterator) Value() *cic.PrivateConnection {
	if len(it.items) == 0 {
		panic("calling Value on empty iterator")
	}
	return it.items[0]
}

func (it *PrivateConnectionIterator) Error() error {
	return it.err
}

// ListOperations implements cic.PrivateConnectionServiceClient
func (c *PrivateConnectionServiceClient) ListOperations(ctx context.Context, in *cic.ListPrivateConnectionOperationsRequest, opts ...grpc.CallOption) (*cic.ListPrivateConnectionOperationsResponse, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewPrivateConnectionServiceClient(conn).ListOperations(ctx, in, opts...)
}

type PrivateConnectionOperationsIterator struct {
	ctx  context.Context
	opts []grpc.CallOption

	err           error
	started       bool
	requestedSize int64
	pageSize      int64

	client  *PrivateConnectionServiceClient
	request *cic.ListPrivateConnectionOperationsRequest

	items []*operation.Operation
}

func (c *PrivateConnectionServiceClient) PrivateConnectionOperationsIterator(ctx context.Context, req *cic.ListPrivateConnectionOperationsRequest, opts ...grpc.CallOption) *PrivateConnectionOperationsIterator {
	var pageSize int64
	const defaultPageSize = 1000
	pageSize = req.PageSize
	if pageSize == 0 {
		pageSize = defaultPageSize
	}
	return &PrivateConnectionOperationsIterator{
		ctx:      ctx,
		opts:     opts,
		client:   c,
		request:  req,
		pageSize: pageSize,
	}
}

func (it *PrivateConnectionOperationsIterator) Next() bool {
	if it.err != nil {
		return false
	}
	if len(it.items) > 1 {
		it.items[0] = nil
		it.items = it.items[1:]
		return true
	}
	it.items = nil // consume last item, if any

	if it.started && it.request.PageToken == "" {
		return false
	}
	it.started = true

	if it.requestedSize == 0 || it.requestedSize > it.pageSize {
		it.request.PageSize = it.pageSize
	} else {
		it.request.PageSize = it.requestedSize
	}

	response, err := it.client.ListOperations(it.ctx, it.request, it.opts...)
	it.err = err
	if err != nil {
		return false
	}

	it.items = response.Operations
	it.request.PageToken = response.NextPageToken
	return len(it.items) > 0
}

func (it *PrivateConnectionOperationsIterator) Take(size int64) ([]*operation.Operation, error) {
	if it.err != nil {
		return nil, it.err
	}

	if size == 0 {
		size = 1 << 32 // something insanely large
	}
	it.requestedSize = size
	defer func() {
		// reset iterator for future calls.
		it.requestedSize = 0
	}()

	var result []*operation.Operation

	for it.requestedSize > 0 && it.Next() {
		it.requestedSize--
		result = append(result, it.Value())
	}

	if it.err != nil {
		return nil, it.err
	}

	return result, nil
}

func (it *PrivateConnectionOperationsIterator) TakeAll() ([]*operation.Operation, error) {
	return it.Take(0)
}

func (it *PrivateConnectionOperationsIterator) Value() *operation.Operation {
	if len(it.items) == 0 {
		panic("calling Value on empty iterator")
	}
	return it.items[0]
}

func (it *PrivateConnectionOperationsIterator) Error() error {
	return it.err
}

// RemoveStaticRoute implements cic.PrivateConnectionServiceClient
func (c *PrivateConnectionServiceClient) RemoveStaticRoute(ctx context.Context, in *cic.RemoveStaticRouteRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewPrivateConnectionServiceClient(conn).RemoveStaticRoute(ctx, in, opts...)
}

// Update implements cic.PrivateConnectionServiceClient
func (c *PrivateConnectionServiceClient) Update(ctx context.Context, in *cic.UpdatePrivateConnectionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewPrivateConnectionServiceClient(conn).Update(ctx, in, opts...)
}

// UpsertStaticRoute implements cic.PrivateConnectionServiceClient
func (c *PrivateConnectionServiceClient) UpsertStaticRoute(ctx context.Context, in *cic.UpsertStaticRouteRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewPrivateConnectionServiceClient(conn).UpsertStaticRoute(ctx, in, opts...)
}
