// Code generated by sdkgen. DO NOT EDIT.

// nolint
package cic

import (
	"context"

	"google.golang.org/grpc"

	cic "github.com/yandex-cloud/go-genproto/yandex/cloud/cic/v1"
	"github.com/yandex-cloud/go-genproto/yandex/cloud/operation"
)

//revive:disable

// TrunkConnectionServiceClient is a cic.TrunkConnectionServiceClient with
// lazy GRPC connection initialization.
type TrunkConnectionServiceClient struct {
	getConn func(ctx context.Context) (*grpc.ClientConn, error)
}

// Create implements cic.TrunkConnectionServiceClient
func (c *TrunkConnectionServiceClient) Create(ctx context.Context, in *cic.CreateTrunkConnectionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewTrunkConnectionServiceClient(conn).Create(ctx, in, opts...)
}

// Delete implements cic.TrunkConnectionServiceClient
func (c *TrunkConnectionServiceClient) Delete(ctx context.Context, in *cic.DeleteTrunkConnectionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewTrunkConnectionServiceClient(conn).Delete(ctx, in, opts...)
}

// Get implements cic.TrunkConnectionServiceClient
func (c *TrunkConnectionServiceClient) Get(ctx context.Context, in *cic.GetTrunkConnectionRequest, opts ...grpc.CallOption) (*cic.TrunkConnection, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewTrunkConnectionServiceClient(conn).Get(ctx, in, opts...)
}

// List implements cic.TrunkConnectionServiceClient
func (c *TrunkConnectionServiceClient) List(ctx context.Context, in *cic.ListTrunkConnectionsRequest, opts ...grpc.CallOption) (*cic.ListTrunkConnectionsResponse, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewTrunkConnectionServiceClient(conn).List(ctx, in, opts...)
}

type TrunkConnectionIterator struct {
	ctx  context.Context
	opts []grpc.CallOption

	err           error
	started       bool
	requestedSize int64
	pageSize      int64

	client  *TrunkConnectionServiceClient
	request *cic.ListTrunkConnectionsRequest

	items []*cic.TrunkConnection
}

func (c *TrunkConnectionServiceClient) TrunkConnectionIterator(ctx context.Context, req *cic.ListTrunkConnectionsRequest, opts ...grpc.CallOption) *TrunkConnectionIterator {
	var pageSize int64
	const defaultPageSize = 1000
	pageSize = req.PageSize
	if pageSize == 0 {
		pageSize = defaultPageSize
	}
	return &TrunkConnectionIterator{
		ctx:      ctx,
		opts:     opts,
		client:   c,
		request:  req,
		pageSize: pageSize,
	}
}

func (it *TrunkConnectionIterator) Next() bool {
	if it.err != nil {
		return false
	}
	if len(it.items) > 1 {
		it.items[0] = nil
		it.items = it.items[1:]
		return true
	}
	it.items = nil // consume last item, if any

	if it.started && it.request.PageToken == "" {
		return false
	}
	it.started = true

	if it.requestedSize == 0 || it.requestedSize > it.pageSize {
		it.request.PageSize = it.pageSize
	} else {
		it.request.PageSize = it.requestedSize
	}

	response, err := it.client.List(it.ctx, it.request, it.opts...)
	it.err = err
	if err != nil {
		return false
	}

	it.items = response.TrunkConnections
	it.request.PageToken = response.NextPageToken
	return len(it.items) > 0
}

func (it *TrunkConnectionIterator) Take(size int64) ([]*cic.TrunkConnection, error) {
	if it.err != nil {
		return nil, it.err
	}

	if size == 0 {
		size = 1 << 32 // something insanely large
	}
	it.requestedSize = size
	defer func() {
		// reset iterator for future calls.
		it.requestedSize = 0
	}()

	var result []*cic.TrunkConnection

	for it.requestedSize > 0 && it.Next() {
		it.requestedSize--
		result = append(result, it.Value())
	}

	if it.err != nil {
		return nil, it.err
	}

	return result, nil
}

func (it *TrunkConnectionIterator) TakeAll() ([]*cic.TrunkConnection, error) {
	return it.Take(0)
}

func (it *TrunkConnectionIterator) Value() *cic.TrunkConnection {
	if len(it.items) == 0 {
		panic("calling Value on empty iterator")
	}
	return it.items[0]
}

func (it *TrunkConnectionIterator) Error() error {
	return it.err
}

// ListOperations implements cic.TrunkConnectionServiceClient
func (c *TrunkConnectionServiceClient) ListOperations(ctx context.Context, in *cic.ListTrunkConnectionOperationsRequest, opts ...grpc.CallOption) (*cic.ListTrunkConnectionOperationsResponse, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewTrunkConnectionServiceClient(conn).ListOperations(ctx, in, opts...)
}

type TrunkConnectionOperationsIterator struct {
	ctx  context.Context
	opts []grpc.CallOption

	err           error
	started       bool
	requestedSize int64
	pageSize      int64

	client  *TrunkConnectionServiceClient
	request *cic.ListTrunkConnectionOperationsRequest

	items []*operation.Operation
}

func (c *TrunkConnectionServiceClient) TrunkConnectionOperationsIterator(ctx context.Context, req *cic.ListTrunkConnectionOperationsRequest, opts ...grpc.CallOption) *TrunkConnectionOperationsIterator {
	var pageSize int64
	const defaultPageSize = 1000
	pageSize = req.PageSize
	if pageSize == 0 {
		pageSize = defaultPageSize
	}
	return &TrunkConnectionOperationsIterator{
		ctx:      ctx,
		opts:     opts,
		client:   c,
		request:  req,
		pageSize: pageSize,
	}
}

func (it *TrunkConnectionOperationsIterator) Next() bool {
	if it.err != nil {
		return false
	}
	if len(it.items) > 1 {
		it.items[0] = nil
		it.items = it.items[1:]
		return true
	}
	it.items = nil // consume last item, if any

	if it.started && it.request.PageToken == "" {
		return false
	}
	it.started = true

	if it.requestedSize == 0 || it.requestedSize > it.pageSize {
		it.request.PageSize = it.pageSize
	} else {
		it.request.PageSize = it.requestedSize
	}

	response, err := it.client.ListOperations(it.ctx, it.request, it.opts...)
	it.err = err
	if err != nil {
		return false
	}

	it.items = response.Operations
	it.request.PageToken = response.NextPageToken
	return len(it.items) > 0
}

func (it *TrunkConnectionOperationsIterator) Take(size int64) ([]*operation.Operation, error) {
	if it.err != nil {
		return nil, it.err
	}

	if size == 0 {
		size = 1 << 32 // something insanely large
	}
	it.requestedSize = size
	defer func() {
		// reset iterator for future calls.
		it.requestedSize = 0
	}()

	var result []*operation.Operation

	for it.requestedSize > 0 && it.Next() {
		it.requestedSize--
		result = append(result, it.Value())
	}

	if it.err != nil {
		return nil, it.err
	}

	return result, nil
}

func (it *TrunkConnectionOperationsIterator) TakeAll() ([]*operation.Operation, error) {
	return it.Take(0)
}

func (it *TrunkConnectionOperationsIterator) Value() *operation.Operation {
	if len(it.items) == 0 {
		panic("calling Value on empty iterator")
	}
	return it.items[0]
}

func (it *TrunkConnectionOperationsIterator) Error() error {
	return it.err
}

// Update implements cic.TrunkConnectionServiceClient
func (c *TrunkConnectionServiceClient) Update(ctx context.Context, in *cic.UpdateTrunkConnectionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return cic.NewTrunkConnectionServiceClient(conn).Update(ctx, in, opts...)
}
